#include "stdafx.h"
#include "hwdeintprop.h"
#include "resource.h"

// -----------------------------------------
// global config structure
CONFIG g_config;

CUnknown * WINAPI CHWDeintProp::CreateInstance(LPUNKNOWN punk, HRESULT *phr)
{
    CHWDeintProp * pNewObject = new CHWDeintProp(punk);
    if (pNewObject == NULL)
	{
        *phr = E_OUTOFMEMORY;
    }
    return pNewObject;
}


CHWDeintProp::CHWDeintProp(LPUNKNOWN pUnk) :
	CBasePropertyPage(NAME("HWDeintProp"), pUnk, IDD_HWDeintProp, IDS_HWDeintProp)
	,m_pHWDeint(0)
{}


HRESULT CHWDeintProp::OnConnect(IUnknown *pUnk)
{
    ASSERT(m_pHWDeint == NULL);
    HRESULT hr;
        // pUnk ŃtB^̃JX^ C^[tFCX₢킹B
    hr = pUnk->QueryInterface(IID_IHWDeint,
             reinterpret_cast<void**>(&m_pHWDeint));
    return hr;
}

HRESULT CHWDeintProp::OnActivate(void)
{
    ASSERT(m_pHWDeint != NULL);
    //m_pOwningFilter->GetSomeProperty(&m_lOldVal);

	// Load Buttons
	SendDlgItemMessage(m_Dlg, IDC_INTERLACE, BM_SETCHECK, g_config.interlace, 0);
	SendDlgItemMessage(m_Dlg, IDC_VIFF1F, BM_SETCHECK, g_config.vif_tff, 0);
	SendDlgItemMessage(m_Dlg, IDC_BOBONLY, BM_SETCHECK, g_config.disp_mode&1, 0);
	SendDlgItemMessage(m_Dlg, IDC_WAVEONLY, BM_SETCHECK, (g_config.disp_mode&2)<<1, 0);
	SendDlgItemMessage(m_Dlg, IDC_BOBORWEAVE, BM_SETCHECK, !g_config.disp_mode, 0);
	SendDlgItemMessage(m_Dlg, IDC_AM2F1F, BM_SETCHECK, g_config.am2_tff, 0);
	SendDlgItemMessage(m_Dlg, IDC_IMEDIA2, BM_SETCHECK, g_config.use_imedia2, 0);
	SendDlgItemMessage(m_Dlg, IDC_WEAVE, BM_SETCHECK, g_config.weave, 0);
	SendDlgItemMessage(m_Dlg, IDC_YUY2, BM_SETCHECK, IsEnable(g_config.colorspace,type_YUY2), 0);
	SendDlgItemMessage(m_Dlg, IDC_UYVY, BM_SETCHECK, IsEnable(g_config.colorspace,type_UYVY), 0);
	SendDlgItemMessage(m_Dlg, IDC_YV12, BM_SETCHECK, IsEnable(g_config.colorspace,type_YV12), 0);
	SendDlgItemMessage(m_Dlg, IDC_NV12, BM_SETCHECK, IsEnable(g_config.colorspace,type_NV12), 0);

	EnableWindow(GetDlgItem(m_Dlg, IDC_VIFF1F), g_config.interlace);
	EnableWindow(GetDlgItem(m_Dlg, IDC_BOBONLY), g_config.interlace);
	EnableWindow(GetDlgItem(m_Dlg, IDC_WAVEONLY), g_config.interlace);
	EnableWindow(GetDlgItem(m_Dlg, IDC_BOBORWEAVE), g_config.interlace);
	EnableWindow(GetDlgItem(m_Dlg, IDC_AM2F1F), g_config.interlace);
	EnableWindow(GetDlgItem(m_Dlg, IDC_IMEDIA2), g_config.interlace);
	EnableWindow(GetDlgItem(m_Dlg, IDC_WEAVE), g_config.use_imedia2&&g_config.interlace);
	EnableWindow(GetDlgItem(m_Dlg, IDC_AM2F1F), g_config.use_imedia2&&g_config.interlace);

    return S_OK;
}

BOOL CHWDeintProp::OnReceiveMessage(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch ( uMsg )
	{
	case WM_DESTROY:
		{
			SaveRegistryInfo();
		}
		break;

	case WM_COMMAND:
		switch ( wParam )
		{
		case IDC_RESET:
			ZeroMemory(&g_config, sizeof(CONFIG));
			g_config.colorspace = type_YUY2;

			SendDlgItemMessage(m_Dlg, IDC_INTERLACE, BM_SETCHECK, g_config.interlace, 0);
			SendDlgItemMessage(m_Dlg, IDC_VIFF1F, BM_SETCHECK, g_config.vif_tff, 0);
			SendDlgItemMessage(m_Dlg, IDC_BOBONLY, BM_SETCHECK, g_config.disp_mode&1, 0);
			SendDlgItemMessage(m_Dlg, IDC_WAVEONLY, BM_SETCHECK, (g_config.disp_mode&2)<<1, 0);
			SendDlgItemMessage(m_Dlg, IDC_BOBORWEAVE, BM_SETCHECK, !g_config.disp_mode, 0);
			SendDlgItemMessage(m_Dlg, IDC_AM2F1F, BM_SETCHECK, g_config.am2_tff, 0);
			SendDlgItemMessage(m_Dlg, IDC_IMEDIA2, BM_SETCHECK, g_config.use_imedia2, 0);
			SendDlgItemMessage(m_Dlg, IDC_WEAVE, BM_SETCHECK, g_config.weave, 0);
			SendDlgItemMessage(m_Dlg, IDC_YUY2, BM_SETCHECK, IsEnable(g_config.colorspace,type_YUY2), 0);
			SendDlgItemMessage(m_Dlg, IDC_UYVY, BM_SETCHECK, IsEnable(g_config.colorspace,type_UYVY), 0);
			SendDlgItemMessage(m_Dlg, IDC_YV12, BM_SETCHECK, IsEnable(g_config.colorspace,type_YV12), 0);
			SendDlgItemMessage(m_Dlg, IDC_NV12, BM_SETCHECK, IsEnable(g_config.colorspace,type_NV12), 0);

			EnableWindow(GetDlgItem(hwnd, IDC_VIFF1F), g_config.interlace);
			EnableWindow(GetDlgItem(hwnd, IDC_BOBONLY), g_config.interlace);
			EnableWindow(GetDlgItem(hwnd, IDC_WAVEONLY), g_config.interlace);
			EnableWindow(GetDlgItem(hwnd, IDC_BOBORWEAVE), g_config.interlace);
			EnableWindow(GetDlgItem(hwnd, IDC_AM2F1F), g_config.interlace);
			EnableWindow(GetDlgItem(hwnd, IDC_IMEDIA2), g_config.interlace);
			EnableWindow(GetDlgItem(hwnd, IDC_WEAVE), g_config.use_imedia2&&g_config.interlace);
			EnableWindow(GetDlgItem(hwnd, IDC_AM2F1F), g_config.use_imedia2&&g_config.interlace);
			
			break;
		case IDC_INTERLACE:
			g_config.interlace = !g_config.interlace;
			EnableWindow(GetDlgItem(hwnd, IDC_VIFF1F), g_config.interlace);
			EnableWindow(GetDlgItem(hwnd, IDC_BOBONLY), g_config.interlace);
			EnableWindow(GetDlgItem(hwnd, IDC_WAVEONLY), g_config.interlace);
			EnableWindow(GetDlgItem(hwnd, IDC_BOBORWEAVE), g_config.interlace);
			EnableWindow(GetDlgItem(hwnd, IDC_AM2F1F), g_config.interlace);
			EnableWindow(GetDlgItem(hwnd, IDC_IMEDIA2), g_config.interlace);
			EnableWindow(GetDlgItem(hwnd, IDC_WEAVE), g_config.use_imedia2&&g_config.interlace);
			EnableWindow(GetDlgItem(hwnd, IDC_AM2F1F), g_config.use_imedia2&&g_config.interlace);
			break;
		case IDC_VIFF1F:
			g_config.vif_tff = !g_config.vif_tff;
			break;
		case IDC_IMEDIA2:
			g_config.use_imedia2 = !g_config.use_imedia2;
			EnableWindow(GetDlgItem(hwnd, IDC_WEAVE), g_config.use_imedia2&&g_config.interlace);
			EnableWindow(GetDlgItem(hwnd, IDC_AM2F1F), g_config.use_imedia2&&g_config.interlace);
			break;
		case IDC_WEAVE:
			g_config.weave = !g_config.weave;
			break;
		case IDC_AM2F1F:
			g_config.am2_tff = !g_config.am2_tff;
			break;
		case IDC_BOBONLY:
			g_config.disp_mode = 1;
			break;
		case IDC_WAVEONLY:
			g_config.disp_mode = 2;
			break;
		case IDC_BOBORWEAVE:
			g_config.disp_mode = 0;
			break;
		case IDC_YUY2:
			g_config.colorspace = NegMask(g_config.colorspace,type_YUY2);
			break;
		case IDC_UYVY:
			g_config.colorspace = NegMask(g_config.colorspace,type_UYVY);
			break;
		case IDC_YV12:
			g_config.colorspace = NegMask(g_config.colorspace,type_YV12);
			break;
		case IDC_NV12:
			g_config.colorspace = NegMask(g_config.colorspace,type_NV12);
			break;
		default :
			return FALSE;
		}
		SaveRegistryInfo();
		break;

	default :
		return FALSE;
	}
	// eNXɃbZ[WB
    return CBasePropertyPage::OnReceiveMessage(hwnd,uMsg,wParam,lParam);
}

HRESULT CHWDeintProp::OnDisconnect(void)
{
    if (m_pHWDeint)
    {
        m_pHWDeint->Release();
        m_pHWDeint = NULL;
    }
    return S_OK;
}




void LoadRegistryInfo()
{
	HKEY hKey;
	DWORD size;
	RegOpenKeyEx(HWDI_REG_KEY, HWDI_REG_SUBKEY, 0, KEY_READ, &hKey);

	REG_GET_N("AMINTERLACE_IsInterlaced", g_config.interlace, 0);
	REG_GET_N("AMINTERLACE_Field1First",  g_config.vif_tff, 0);
	REG_GET_N("use IMediaSample2", g_config.use_imedia2, 0);
	REG_GET_N("AM_VIDEO_FLAG_WEAVE",  g_config.weave, 0);
    REG_GET_N("AM_VIDEO_FLAG_FIELD1FIRST", g_config.am2_tff, 0);
	REG_GET_N("AMINTERLACE_DisplayMode",  g_config.disp_mode, 0);
	REG_GET_N("ColorSpace",  g_config.colorspace, 0);

	RegCloseKey(hKey);
}

void SaveRegistryInfo()
{
	HKEY hKey;
	DWORD dispo;

	if (RegCreateKeyEx(
			HWDI_REG_KEY,
			HWDI_REG_SUBKEY,
			0,
			HWDI_REG_CLASS,
			REG_OPTION_NON_VOLATILE,
			KEY_WRITE,
			0, 
			&hKey, 
			&dispo) != ERROR_SUCCESS)
	{
		OutputDebugString("Couldn't create HWDI_REG_SUBKEY");
		return;
	}

	REG_SET_N("AMINTERLACE_IsInterlaced", g_config.interlace);
	REG_SET_N("AMINTERLACE_Field1First",  g_config.vif_tff);
	REG_SET_N("use IMediaSample2", g_config.use_imedia2);
	REG_SET_N("AM_VIDEO_FLAG_WEAVE",  g_config.weave);
	REG_SET_N("AM_VIDEO_FLAG_FIELD1FIRST", g_config.am2_tff);
	REG_SET_N("AMINTERLACE_DisplayMode",  g_config.disp_mode);
	REG_SET_N("ColorSpace",  g_config.colorspace);

	RegCloseKey(hKey);
}

